SystemOrganization addCategory: #'Sight-Fixed'!

Object subclass: #SFixedCstSimulator
	instanceVariableNames: 'event fixedMaintainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Fixed'!

!SFixedCstSimulator methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 15:04:48.366'!
ensureCollection: oneOrMany
	^ oneOrMany isCompiledMethod ifTrue: [{oneOrMany}] ifFalse: [oneOrMany]! !

!SFixedCstSimulator methodsFor: 'accessing' stamp: 'bs 8/20/2010 14:28:57.844'!
event
	^ event! !

!SFixedCstSimulator methodsFor: 'accessing' stamp: 'bs 8/20/2010 14:28:57.851'!
event: anObject
	event := anObject! !

!SFixedCstSimulator methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 15:00:53.683'!
failedInclude: oneOrManyFailed
	self passedInclude: {} failedInclude: oneOrManyFailed! !

!SFixedCstSimulator methodsFor: 'accessing' stamp: 'bs 8/20/2010 14:32:43.85'!
fixedMaintainer
	^ fixedMaintainer! !

!SFixedCstSimulator methodsFor: 'accessing' stamp: 'bs 8/20/2010 14:32:43.856'!
fixedMaintainer: anObject
	fixedMaintainer := anObject! !

!SFixedCstSimulator methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 15:01:11.09'!
passedInclude: oneOrManyPassed 
	self passedInclude: oneOrManyPassed failedInclude: {}! !

!SFixedCstSimulator methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 14:38:40.833'!
passedInclude: oneOrManyPassed failedInclude: oneOrManyFailed
	self testResult: 
			(STestResult 
				withPassedTests: (self ensureCollection: oneOrManyPassed)
				withFailedTests: (self ensureCollection: oneOrManyFailed)).! !

!SFixedCstSimulator methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 14:34:02.637'!
testResult: aTestResult
	| sightEvent |
	sightEvent := SSystemEventAnalyzer new analyze: self event.
	sightEvent testResult: aTestResult.
	self fixedMaintainer postprocess: sightEvent! !

Object subclass: #SFixedFoo
	instanceVariableNames: 'testsToBeFixed unassignedMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Fixed'!

!SFixedFoo methodsFor: 'accessing' stamp: 'bs 8/5/2010 08:09:56.365'!
addTestToBeFixed: aCompiledTestMethod
	^ self pvtTestsToBeFixed add: aCompiledTestMethod! !

!SFixedFoo methodsFor: 'accessing' stamp: 'bs 8/5/2010 11:33:04.013'!
addUnassignedMethod: aMethod
	self pvtUnassignedMethods add: aMethod uninstrumentedMethod.! !

!SFixedFoo methodsFor: 'system event handling' stamp: 'bs 8/22/2010 21:41:09.159'!
assignMethodsToFixedTests: fixedTestMethods
	| assignedMethods |
	assignedMethods := IdentitySet new.
	fixedTestMethods do: [:testMethod | 
		self unassignedMethods 
			select: [:ea | testMethod coveredMethods includes: ea]
			thenDo: [:ea | ea fixes: testMethod. assignedMethods add: ea] ].
	assignedMethods do: [:ea | self removeUnassignedMethod: ea].! !

!SFixedFoo methodsFor: 'system event handling' stamp: 'bs 8/5/2010 11:31:05.809'!
fixedTestMethods: aTestResult
	^ aTestResult passed 
		collect: [ :aTestCase | aTestCase selectedMethod] 
		thenSelect: [ :aTestMethod | self testsToBeFixed includes: aTestMethod ]! !

!SFixedFoo methodsFor: 'system event handling' stamp: 'bs 8/5/2010 14:38:02.103'!
handleFixed: aTestResult
	| fixedTests |
	fixedTests := self fixedTestMethods: aTestResult.
	fixedTests do: [:aFixedTest | 
		(aFixedTest methodsThatFixedTest) do: [:method | 
			(aFixedTest coveredMethods includes: method)
				ifFalse: [method removeFixedTestMethod: aFixedTest] ] ].
	(fixedTests) do: [:ea | self removeTestToBeFixed: ea].
	self assignMethodsToFixedTests: fixedTests.
	self testsToBeFixed ifEmpty: [self resetUnassignedMethods]! !

!SFixedFoo methodsFor: 'system event handling' stamp: 'bs 8/22/2010 20:44:46.176'!
nonTestMethodModifiedFrom: oldMethod to: newMethod
	(self unassignedMethods includes: oldMethod)
		ifTrue: [
			self removeUnassignedMethod: oldMethod.
			self addUnassignedMethod: newMethod].! !

!SFixedFoo methodsFor: 'system event handling' stamp: 'bs 8/5/2010 21:09:16.671'!
nonTestMethodRemoved: aMethod
	self removeUnassignedMethod: aMethod! !

!SFixedFoo methodsFor: 'accessing' stamp: 'bs 8/5/2010 20:46:44.219'!
pvtTestsToBeFixed
	^ testsToBeFixed ifNil: [testsToBeFixed := IdentitySet new]! !

!SFixedFoo methodsFor: 'accessing' stamp: 'bs 8/5/2010 11:33:15.481'!
pvtUnassignedMethods
	^ unassignedMethods ifNil: [unassignedMethods := IdentitySet new]! !

!SFixedFoo methodsFor: 'accessing' stamp: 'bs 8/5/2010 11:00:55.087'!
removeTestToBeFixed: aTestMethod
	^ self pvtTestsToBeFixed remove: aTestMethod ifAbsent: []! !

!SFixedFoo methodsFor: 'accessing' stamp: 'bs 8/5/2010 11:33:20.206'!
removeUnassignedMethod: aMethod
	self pvtUnassignedMethods remove: aMethod uninstrumentedMethod ifAbsent: []! !

!SFixedFoo methodsFor: 'accessing' stamp: 'bs 8/5/2010 11:33:26.173'!
resetUnassignedMethods
	^ unassignedMethods := nil! !

!SFixedFoo methodsFor: 'system event handling' stamp: 'bs 8/5/2010 21:08:54.254'!
testMethodRemoved: aTestMethod 
	self removeTestToBeFixed: aTestMethod.! !

!SFixedFoo methodsFor: 'accessing' stamp: 'bs 8/5/2010 08:09:36.496'!
testsToBeFixed
	^ self pvtTestsToBeFixed copy! !

!SFixedFoo methodsFor: 'accessing' stamp: 'bs 8/5/2010 11:33:08.585'!
unassignedMethods
	^ self pvtUnassignedMethods copy! !

Object subclass: #SFixedMaintainer
	instanceVariableNames: 'newBehavior refactoring renamingCandidate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Fixed'!

!SFixedMaintainer methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 14:41:48.007'!
allTestsToBeFixed
	^ self newTestsToBeFixed, self brokenTestsToBeRefixed! !

!SFixedMaintainer methodsFor: 'as yet unclassified' stamp: 'bs 8/5/2010 09:22:33.874'!
brokenTestsToBeRefixed
	^ self refactoring testsToBeFixed! !

!SFixedMaintainer methodsFor: 'as yet unclassified' stamp: 'bs 8/22/2010 20:57:50.333'!
isInNewBehaviorMode
	^ self isInRefactoringMode not! !

!SFixedMaintainer methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 16:31:47.558'!
isInRefactoringMode
	^ self brokenTestsToBeRefixed isEmpty not! !

!SFixedMaintainer methodsFor: 'event processing' stamp: 'bs 8/19/2010 10:06:35.366'!
isSimilarToBlock: referenceMethod
	^ [:methodToTest | 
			methodToTest qualifiedName = referenceMethod qualifiedName]! !

!SFixedMaintainer methodsFor: 'system event handling' stamp: 'bs 8/6/2010 11:19:17.705'!
methodAdded: addedMethod testResult: aTestResult
	addedMethod isTestMethod
		ifTrue: [self testMethodAdded: addedMethod testResult: aTestResult]
		ifFalse: [self nonTestMethodAdded: addedMethod]! !

!SFixedMaintainer methodsFor: 'system event handling' stamp: 'bs 8/19/2010 09:57:20.855'!
methodModifiedFrom: oldMethod to: currentMethod testResult: aTestResult
	currentMethod isTestMethod
		ifTrue: [
			self testMethodModifiedFrom: oldMethod 
				 to: currentMethod 
				 testResult: aTestResult]
		ifFalse: [
			self nonTestMethodModifiedFrom: oldMethod
				 to: currentMethod
				 testResult: aTestResult]! !

!SFixedMaintainer methodsFor: 'system event handling' stamp: 'bs 8/5/2010 21:16:37.034'!
methodRemoved: removedMethod testResult: aTestResult
	removedMethod isTestMethod
		ifTrue: [self testMethodRemoved: removedMethod]
		ifFalse: [self nonTestMethodRemoved: removedMethod]! !

!SFixedMaintainer methodsFor: 'accessing' stamp: 'bs 8/6/2010 18:05:52.065'!
newBehavior
	^ newBehavior ifNil: [newBehavior := SFixedFoo new] ! !

!SFixedMaintainer methodsFor: 'as yet unclassified' stamp: 'bs 8/5/2010 09:22:20.373'!
newTestsToBeFixed
	^ self newBehavior testsToBeFixed! !

!SFixedMaintainer methodsFor: 'system event handling' stamp: 'bs 8/22/2010 21:27:02.959'!
nonTestMethodAdded: modifiedMethod
	self isInRefactoringMode 
		ifTrue: [self refactoring addUnassignedMethod: modifiedMethod]
		ifFalse: [self newBehavior addUnassignedMethod: modifiedMethod]! !

!SFixedMaintainer methodsFor: 'system event handling' stamp: 'bs 8/22/2010 20:55:01.216'!
nonTestMethodModifiedFrom: oldMethod to: currentMethod testResult: aTestResult
	| fixedTestMethods testsToBeRefixed newTestsToBeRefixed |
	fixedTestMethods := oldMethod fixedTestMethods.
	oldMethod resetFixedTestMethods.
	{self newBehavior. self refactoring} do: [:ea | 
		ea nonTestMethodModifiedFrom: oldMethod to: currentMethod].
	self nonTestMethodAdded: currentMethod.
	fixedTestMethods do: [:ea | currentMethod fixes: ea].
	testsToBeRefixed := fixedTestMethods intersection: aTestResult defectTestMethods.
	newTestsToBeRefixed := testsToBeRefixed difference: self allTestsToBeFixed.
	newTestsToBeRefixed do: [:ea | self refactoring addTestToBeFixed: ea].! !

!SFixedMaintainer methodsFor: 'system event handling' stamp: 'bs 8/5/2010 21:09:49.004'!
nonTestMethodRemoved: removedMethod
	{self newBehavior. self refactoring} do: [:ea | 
		ea nonTestMethodRemoved: removedMethod ].
	removedMethod resetFixedTestMethods! !

!SFixedMaintainer methodsFor: 'event processing' stamp: 'bs 8/20/2010 17:20:50.969'!
postprocess: aSightEvent
	| removeds addeds replacings modifications replaceds |	
	removeds := aSightEvent removedMethods.
	addeds := aSightEvent addedMethods.
	
	replacings := addeds select: [:ea | removeds anySatisfy: (self isSimilarToBlock: ea)].
	(addeds difference: replacings) do: [:newMethod | 
		self methodAdded: newMethod testResult: aSightEvent testResult].
	
	modifications := replacings collect: [:eachAdded | 
		{eachAdded. removeds detect: (self isSimilarToBlock: eachAdded)}].
	replaceds := modifications collect: [:ea | ea second].
	
	(removeds difference: replaceds) do: [:ea | 
		self methodRemoved: ea testResult: aSightEvent testResult].
	
	modifications do: [:ea | 
		self methodModifiedFrom: ea second to: ea first testResult: aSightEvent testResult]. 
	
	{self newBehavior. self refactoring} do: [:ea | ea handleFixed: aSightEvent testResult].

	aSightEvent testResult passedTestMethods do: [:passedTest | 
		(passedTest methodsThatFixedTest difference: passedTest coveredMethods) 
			do: [:ea | ea removeFixedTestMethod: passedTest]].! !

!SFixedMaintainer methodsFor: 'event processing' stamp: 'bs 8/19/2010 16:28:06.489'!
preprocess: aSightEvent
	self processTwoStepMethodRenamings: aSightEvent! !

!SFixedMaintainer methodsFor: 'event processing' stamp: 'bs 8/10/2010 17:13:21.431'!
process: aSightEvent! !

!SFixedMaintainer methodsFor: 'event processing' stamp: 'bs 8/19/2010 21:15:00.084'!
processTwoStepMethodRenamings: aSightEvent
	| removedMethod |
	(aSightEvent addedMethods isEmpty and: [aSightEvent removedMethods size = 1])
		ifTrue: [
			removedMethod := aSightEvent removedMethods anyOne.
			self renamingCandidate ifNotNil: [ 
				(removedMethod methodClass = self renamingCandidate methodClass) 
					ifTrue: [
						removedMethod isTestMethod 
							ifTrue: [
								 (removedMethod coveredMethods = self renamingCandidate coveredMethods)
									ifTrue: [
										removedMethod methodsThatFixedTest do: [:ea | 
											ea fixes: self renamingCandidate ]]]]]].
	
	self resetRenamingCandidate.
	
	(aSightEvent removedMethods isEmpty and: [aSightEvent addedMethods size = 1])
		ifTrue: [
			self renamingCandidate:  aSightEvent addedMethods anyOne]! !

!SFixedMaintainer methodsFor: 'accessing' stamp: 'bs 8/6/2010 18:05:52.059'!
refactoring
	^ refactoring ifNil: [refactoring := SFixedFoo new] ! !

!SFixedMaintainer methodsFor: 'event processing' stamp: 'bs 8/19/2010 15:36:59.464'!
renamingCandidate
	^ renamingCandidate! !

!SFixedMaintainer methodsFor: 'event processing' stamp: 'bs 8/19/2010 15:37:08.165'!
renamingCandidate: aMethod
	^ renamingCandidate := aMethod! !

!SFixedMaintainer methodsFor: 'event processing' stamp: 'bs 8/19/2010 15:48:22.337'!
resetRenamingCandidate
	renamingCandidate := nil! !

!SFixedMaintainer methodsFor: 'system event handling' stamp: 'bs 8/10/2010 17:34:02.689'!
testMethodAdded: aTestMethod testResult: aTestResult
	self assert: (aTestResult testMethods includes: aTestMethod).
	(aTestResult isDefect: aTestMethod) 
		ifTrue: [self newBehavior addTestToBeFixed: aTestMethod]
	.! !

!SFixedMaintainer methodsFor: 'system event handling' stamp: 'bs 8/17/2010 19:03:05.258'!
testMethodModifiedFrom: oldTestMethod to: currentTestMethod testResult: aTestResult
	| methodsThatFixedTest |
	methodsThatFixedTest := oldTestMethod methodsThatFixedTest.
	self testMethodRemoved: oldTestMethod.
	self testMethodAdded: currentTestMethod testResult: aTestResult.
	methodsThatFixedTest do: [:ea | ea fixes: currentTestMethod].! !

!SFixedMaintainer methodsFor: 'system event handling' stamp: 'bs 8/5/2010 21:10:00.744'!
testMethodRemoved: aTestMethod
	{self newBehavior. self refactoring} do: [:ea | 
		ea testMethodRemoved: aTestMethod ].
	aTestMethod resetMethodsThatFixedTest.! !

SCoverageTestCase subclass: #SFixedTestCase
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Fixed'!

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/22/2010 09:02:46.46'!
addedEvent: aMethod
	^ AddedEvent 
		method: aMethod
		selector: aMethod selector 
		class: aMethod methodClass! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 14:30:27.109'!
afterAdding: aMethod
	^ self afterEvent: (self addedEvent: aMethod)! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/22/2010 20:29:46.794'!
afterEvent: anEvent
	^ SFixedCstSimulator new 
		event: anEvent;
		fixedMaintainer: sut
		yourself! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/22/2010 21:44:08.217'!
afterModifying: aMethod
	| newMethod |
	newMethod := aMethod copy.
	newMethod installSilently.
	aMethod coveringTestMethods do: [:ea| ea called: newMethod].
	^ self afterEvent: (self modifiedEventFrom: aMethod to: newMethod).! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 15:44:02.511'!
assert: aNonTestMethod fixes: aTestMethod
	^ self assert: (aNonTestMethod fixedTestMethods includes: aTestMethod)! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 15:38:31.808'!
event: aSystemEvent failedTest: failedTestMethod 
	self event: aSystemEvent passedTests: {} failedTests: {failedTestMethod}! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 15:38:22.032'!
event: aSystemEvent failedTests: failedTestMethods 
	self event: aSystemEvent passedTests: {} failedTests: failedTestMethods! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 15:38:47.756'!
event: aSystemEvent passedTest: passedTestMethod 
	self event: aSystemEvent passedTests: {passedTestMethod} failedTests: {}! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 15:33:16.338'!
event: aSystemEvent passedTest: passedTestMethod failedTest: failedTestMethod
	self event: aSystemEvent passedTests: {passedTestMethod} failedTests: {failedTestMethod}! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 15:38:07.652'!
event: aSystemEvent passedTests: passedTestMethods 
	self event: aSystemEvent passedTests: passedTestMethods failedTests: {}! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 15:37:26.935'!
event: aSystemEvent passedTests: passedTestMethods failedTests: failedTestMethods
	self event: aSystemEvent
		 testResult: 
			(STestResult 
				withPassedTests: passedTestMethods
				withFailedTests: failedTestMethods).! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2010 18:42:55.337'!
event: aSystemEvent testResult: aTestResult
	| sightEvent |
	sightEvent := SSystemEventAnalyzer new analyze: aSystemEvent.
	sightEvent testResult: aTestResult.
	sut postprocess: sightEvent! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/5/2010 21:54:26.26'!
modifiedEvent: aMethod
	^ self modifiedEventFrom: aMethod to: aMethod! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/5/2010 21:54:15.79'!
modifiedEventFrom: oldMethod to: newMethod
	^ ModifiedEvent 
		methodChangedFrom: oldMethod
		to: newMethod
		selector: newMethod selector
		inClass: newMethod methodClass! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/22/2010 09:02:37.201'!
removedEvent: aMethod
	^ RemovedEvent 
		method: aMethod
		selector: aMethod selector 
		class: aMethod methodClass! !

!SFixedTestCase methodsFor: 'running' stamp: 'bs 8/10/2010 18:35:09.135'!
setUp
	super setUp.
	self tracePackage: self tbPackage.
	self runTbTests.
	sut := SFixedMaintainer new.! !

!SFixedTestCase methodsFor: 'accessing' stamp: 'bs 7/29/2010 13:23:39.323'!
tbExampleMethod
	^ super tbExampleMethod uninstrumentedMethod! !

!SFixedTestCase methodsFor: 'running' stamp: 'bs 7/29/2010 12:07:25.179'!
tearDown
	super tearDown.
	self tbMethods do: [:ea |
		ea isTestMethod 
			ifTrue: [ea resetMethodsThatFixedTest]
			ifFalse: [ea resetFixedTestMethods] ].
	sut := nil.! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 17:59:43.465'!
test01OneModificationToFixOneTest
	self event: (self modifiedEvent: self tbTestMethod)
		testResult: (STestResult withFailedTest: self tbTestMethod).
	
	self event: (self addedEvent: self tbFirstnameGetter)
		testResult: (STestResult withPassedTest: self tbTestMethod).
	
	self assert: self tbFirstnameGetter hasFixedTestMethods.
	self assert: (self tbFirstnameGetter fixedTestMethods includes: self exampleTestMethod)! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/5/2010 20:47:19.797'!
test02MultipleModificationsToFixMultipleTest
	| addedMethods |
	self event: (self modifiedEvent: self tbTestMethod)
		testResult: (STestResult withFailedTest: self tbTestMethod).
	
	addedMethods := { self tbFirstnameSetter. self tbFirstnameGetter }.
	self event: (self addedEvent: addedMethods first)
		testResult: (STestResult withFailedTest: self tbTestMethod).
		
	self event: (self addedEvent: addedMethods second)
		testResult: (STestResult withPassedTest: self tbTestMethod).
	
	self assert: (addedMethods allSatisfy: [:ea | ea hasFixedTestMethods])! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 14:18:25.757'!
test03ModifyAndRemoveToFixOneTest
	self event: (self modifiedEvent: self tbTestMethod)
		testResult: (STestResult withFailedTest: self tbTestMethod).
	
	self event: (self addedEvent: self tbFirstnameGetter)
		testResult: (STestResult withFailedTest: self tbTestMethod).
		
	self event: (self removedEvent: self tbFirstnameGetter)
		testResult: (STestResult withFailedTest: self tbTestMethod).
	
	self event: (self addedEvent: self tbFirstnameSetter)
		testResult: (STestResult withPassedTest: self tbTestMethod).
	
	self deny: self tbFirstnameGetter hasFixedTestMethods.
	self assert: self tbFirstnameSetter hasFixedTestMethods.! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/19/2010 14:16:45.699'!
test04ModificationOfUncoveredMethod
	| uncoveredMethod|
	uncoveredMethod := Complex >> #arg.
	self ensureInTearDown: [uncoveredMethod resetMethodExtension].
	
	self event: (self addedEvent: self tbTestMethod)
		testResult: (STestResult withFailedTest: self tbTestMethod).
	
	self event: (self addedEvent: uncoveredMethod)
		testResult: (STestResult withFailedTest: self tbTestMethod).
	
	self event: (self addedEvent: self tbFirstnameSetter)
		testResult: (STestResult withPassedTest: self tbTestMethod).
	
	self deny: uncoveredMethod hasFixedTestMethods.
	self assert: self tbFirstnameSetter hasFixedTestMethods.! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 14:18:07.694'!
test05RemoveTestMethod
	self event: (self addedEvent: self tbTestMethod)
		testResult: (STestResult withFailedTest: self tbTestMethod).

	self assert: (sut newTestsToBeFixed includes: self tbTestMethod).	

	self event: (self removedEvent: self tbTestMethod)
		testResult: (STestResult new).
	
	self deny: (sut newTestsToBeFixed includes: self tbTestMethod).! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/5/2010 21:40:30.433'!
test06RefactoringWithinMethod
	| tests |
	tests := {self tbTestMethod. self tbTestMethod2}.
	
	self tbFirstnameSetter fixes: self tbTestMethod2.
	
	self event: (self modifiedEvent: self tbFirstnameSetter)
		testResult: (STestResult withFailedTests: tests).

	self event: (self modifiedEvent: self tbFirstnameSetter)
		testResult: (STestResult withPassedTests: tests).
	
	self deny: (self tbFirstnameSetter fixedTestMethods includes: self tbTestMethod).
	self assert: (self tbFirstnameSetter fixedTestMethods includes: self tbTestMethod2)! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/19/2010 14:16:50.806'!
test07MaintainingFixedRelWhenModifyingMethod
	| methodv1 methodv2  | 
	methodv1 := self tbExampleMethod.
	self ensureInTearDown: [methodv1 resetFixedTestMethods].
	
	methodv1 fixes: self tbTestMethod.
	
	self recompile: methodv1.
	methodv2 := self tbExampleMethod.
	self runTbTests.
	
	self event: (self modifiedEventFrom: methodv1 to: methodv2)
		 testResult: (STestResult withPassedTest: self tbTestMethod).
		
	self deny: (methodv1 fixedTestMethods includes: self tbTestMethod).
	self assert: (methodv2 fixedTestMethods includes: self tbTestMethod)! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/19/2010 11:30:22.04'!
test09RemovalOfAssignedMethods
	{self tbTestMethod. self tbTestMethod2} do: [:ea | 
		self event: (self modifiedEvent: ea)
			testResult: (STestResult withFailedTest: ea) ].

	self event: (self modifiedEvent: self tbExampleMethod)
		testResult: (STestResult withPassedTest: self tbTestMethod 
								 withFailedTest: self tbTestMethod2).
	
	self event: (self modifiedEvent: self tbExampleMethod2)
		testResult: (STestResult withPassedTest: self tbTestMethod2).
		
	self deny: (self tbExampleMethod fixedTestMethods includes: self tbTestMethod2).! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 15:17:35.677'!
test10FixedRelationship
	self tbExampleMethod fixes: self tbTestMethod. 
	self assert: (self tbExampleMethod fixedTestMethods includes: self tbTestMethod).
	self assert: (self tbTestMethod methodsThatFixedTest includes: self tbExampleMethod).
	
	self tbExampleMethod resetFixedTestMethods.
	self deny: (self tbTestMethod methodsThatFixedTest includes: self tbExampleMethod).

	self tbExampleMethod fixes: self tbTestMethod.
	self tbTestMethod resetMethodsThatFixedTest.
	self deny: (self tbExampleMethod fixedTestMethods includes: self tbTestMethod)! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 14:07:46.097'!
test11ToBeFixedOrRefixed
	self event: (self addedEvent: self tbTestMethod)
		testResult: (STestResult withFailedTest: self tbTestMethod).
	self assert: (sut newTestsToBeFixed includes: self tbTestMethod).
	self deny: (sut brokenTestsToBeRefixed includes: self tbTestMethod).! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 15:00:17.362'!
test12AddNewPassingTestWhileFixingAnother
	(self afterAdding: self tbTestMethod) failedInclude: self tbTestMethod.
	(self afterAdding: self tbExampleMethod) failedInclude: self tbTestMethod.
	(self afterAdding: self tbTestMethod2) passedInclude: self tbTestMethod2.
	self deny: (self tbExampleMethod fixedTestMethods includes: self tbTestMethod2)! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 15:09:24.657'!
test12FixNewTestWhileFixingAnother
	(self afterAdding: self tbTestMethod) failedInclude: self tbTestMethod.
	(self afterAdding: self tbExampleMethod) failedInclude: self tbTestMethod.
	(self afterAdding: self tbTestMethod2) passedInclude: self tbTestMethod2.
	self deny: (self tbExampleMethod fixedTestMethods includes: self tbTestMethod2)! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 15:05:14.77'!
test13
	(self afterAdding: self tbTestMethod) failedInclude: self tbTestMethod.
	(self afterModifying: self tbExampleMethod) failedInclude: {self tbTestMethod. self tbTestMethod2}.
	
	self assert: 1 equals: sut newTestsToBeFixed size.
	self assert: (sut newTestsToBeFixed includes: self tbTestMethod).
	self assert: sut brokenTestsToBeRefixed isEmpty! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 15:17:55.966'!
test14
	self tbExampleMethod fixes: self tbTestMethod2.
	
	self event: (self addedEvent: self tbTestMethod)
		testResult: (STestResult withFailedTest: self tbTestMethod).
	self event: (self modifiedEvent: self tbExampleMethod)
		testResult: (STestResult withFailedTests: {self tbTestMethod. self tbTestMethod2}).
	
	self assert: 1 equals: sut brokenTestsToBeRefixed size.
	self assert: (sut brokenTestsToBeRefixed includes: self tbTestMethod2)! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/6/2010 17:01:40.9'!
test15
	self tbExampleMethod fixes: self tbTestMethod.
	
	self event: (self addedEvent: self tbTestMethod2)
		 failedTest: self tbTestMethod2.
	
	self event: (self modifiedEvent: self tbExampleMethod)
		 failedTests: {self tbTestMethod. self tbTestMethod2}.
	
	self event: (self modifiedEvent: self tbExampleMethod2)
		 passedTest: self tbTestMethod failedTest: self tbTestMethod2.
	
	self assert: self tbExampleMethod fixes: self tbTestMethod.
	self assert: self tbExampleMethod2 fixes: self tbTestMethod.
	
	
	self event: (self modifiedEvent: self tbExampleMethod)
		 passedTests: {self tbTestMethod. self tbTestMethod2}.
		
	self assert: self tbExampleMethod fixes: self tbTestMethod2.! !

!SFixedTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/22/2010 21:43:58.918'!
test16RememberFixingMethodsDuringRefactoring
	self tbExampleMethod fixes: self tbTestMethod.
	(self afterAdding: self tbTestMethod2) failedInclude: self tbTestMethod2.
	self assert: sut isInNewBehaviorMode.
	(self afterModifying: self tbExampleMethod) failedInclude: {self tbTestMethod2. self tbTestMethod}.
	self assert: sut isInRefactoringMode.
	
	(self afterModifying: self tbExampleMethod) passedInclude: self tbTestMethod failedInclude: self tbTestMethod2.
	self assert: sut isInNewBehaviorMode.
	self assert: self tbExampleMethod fixes: self tbTestMethod.
	
	(self afterModifying: self tbExampleMethod2) passedInclude: self tbTestMethod2.
	self assert: sut isInNewBehaviorMode.
	self assert: self tbExampleMethod2 fixes: self tbTestMethod2.
	self assert: self tbExampleMethod fixes: self tbTestMethod2.! !

SCstTestCase subclass: #SFixedIntegrationTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Fixed'!

SFixedIntegrationTestCase subclass: #SFixedClassEventsTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Fixed'!

!SFixedClassEventsTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2010 23:03:59.816'!
testClassModified
	self tbExampleMethod fixes: self tbTestMethod.
	(STbPerson instVarNames includes: 'f') 
		ifFalse: [self addInstVar: 'f' to: STbPerson].
	self assert: self tbExampleMethod fixedTestMethods size = 1.! !

!SFixedIntegrationTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 13:40:11.717'!
renameMethod: aMethod to: newSelector
	| newSelectorSymbol |
	newSelectorSymbol := newSelector asSymbol.
	(RenameMethodRefactoring 
		renameMethod: aMethod selector 
		in: aMethod methodClass 
		to: newSelectorSymbol 
		permutation: {}) 
			execute.
	self ensureInTearDown: [
		aMethod isTestMethod
			ifTrue: [aMethod resetMethodsThatFixedTest]
			ifFalse: [aMethod resetFixedTestMethods]].
	^ aMethod methodClass >> newSelectorSymbol! !

!SFixedIntegrationTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/19/2010 14:45:49.59'!
tbExampleMethod
	^ super tbExampleMethod uninstrumentedMethod! !

!SFixedIntegrationTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/19/2010 14:16:34.306'!
test05ModifyingTestMethod
	| testMethodv1 testMethodv2 | 
	testMethodv1 := self tbTestMethod.
	self ensureInTearDown: [testMethodv1 resetMethodsThatFixedTest].
	
	self tbExampleMethod fixes: testMethodv1.
	self recompile: testMethodv1.
	testMethodv2 := self tbTestMethod.
	
	self deny: (testMethodv1 methodsThatFixedTest includes: self tbExampleMethod uninstrumentedMethod).
	self assert: (testMethodv2 methodsThatFixedTest includes: self tbExampleMethod uninstrumentedMethod).! !

!SFixedIntegrationTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/19/2010 21:05:04.907'!
test06RenamingTestMethod
	| testMethod testMethodNew | 
	testMethod := self tbTestMethod.
	self runTestMethods: {testMethod}.
	self tbExampleMethod fixes: testMethod.

	testMethodNew := self renameMethod: testMethod to: testMethod selector, 'New'.
	self ensureInTearDown: [ 
		testMethodNew isInstalled ifTrue: [
			self renameMethod: testMethodNew to: testMethod selector]].
	
	self deny: (testMethod methodsThatFixedTest includes: self tbExampleMethod).
	self assert: (testMethodNew methodsThatFixedTest includes: self tbExampleMethod).
	
	self renameMethod: testMethodNew to: testMethod selector.
	self deny: (testMethodNew methodsThatFixedTest includes: self tbExampleMethod).
	self assert: (self tbTestMethod methodsThatFixedTest includes: self tbExampleMethod).! !

!SFixedIntegrationTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 13:55:25.843'!
test07RenamingNonTestMethod
	| method methodNew | 
	method :=  (STbPerson >> #firstname) unwrappedMethod.
	self runTestMethods: {self tbTestMethod}.
	method fixes: self tbTestMethod.

	methodNew := self renameMethod: method to: method selector, 'New'.
	self ensureInTearDown: [ 
		methodNew isInstalled ifTrue: [
			self renameMethod: methodNew to:method selector]].
	"
	self deny: (method fixedTestMethods includes: self tbTestMethod).
	self assert: (methodNew fixedTestMethods includes: self tbTestMethod).
	
	self renameMethod: methodNew to: method selector.
	self deny: (methodNew fixedTestMethods includes: self tbTestMethod).
	self assert: (method fixedTestMethods includes: self tbTestMethod)."! !

!SFixedIntegrationTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/20/2010 17:14:27.292'!
test08ResetFixedWhenNotCoveringAnymore
	self ensureInTearDown: [self compileExampleTestMethod].
	self runTestMethods: {self exampleTestMethod}.
	self exampleMethod fixes: self exampleTestMethod.
	
	self exampleTestMethod methodClass compile: self exampleTestMethod selector asString.
	self deny: (self exampleMethod fixedTestMethods includes: self exampleTestMethod)
	! !

!SFixedIntegrationTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/9/2010 14:03:52.578'!
testEstablishingFixedRelationship
	self undoInTearDownDo: [
		self removeMethod: self exampleMethod ].
	 
	STbPersonTest compile: self exampleTestMethodSource.
	STbPerson compile: self exampleMethodSource. 
	
	self should: [ self exampleMethod hasCoveringTestMethods ].
	self should: [ self exampleMethod hasFixedTestMethods ].
	! !

!SFixedIntegrationTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/11/2010 11:39:49.845'!
testFixedTestMethods
	self tbExampleMethod fixes: self tbTestMethod. 
	self assert: self tbExampleMethod fixedTestMethods size = 1.
	self tbExampleMethod resetFixedTestMethods.	
	self assert: self tbExampleMethod fixedTestMethods size = 0.! !

!SFixedIntegrationTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2010 21:36:46.216'!
testRecompiling
	self tbExampleMethod fixes: self tbTestMethod.
	self assert: self tbExampleMethod fixedTestMethods size = 1.
	self recompile: self tbExampleMethod.
	self assert: self tbExampleMethod fixedTestMethods size = 1.! !

!SFixedIntegrationTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/11/2010 12:07:49.885'!
testRemoveOfOverriddenMethod
	| personsubclass selector overridenMethod superCallTestSelector |
	selector := #asString.
	overridenMethod := STbPerson >> selector.
	
	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		personsubclass compile: (STbPerson sourceCodeAt: selector).
		superCallTestSelector := self installMethod: self createSuperCallTestCode 
									    inClass: STbPersonTest ].
	
	overridenMethod fixes: (STbPersonTest >> superCallTestSelector).
	self undoInTearDownDo: [self removeMethod: overridenMethod].
	"self assert: (personsubclass >> selector) hasFixedTestMethods."! !
